#ifndef __app_params_h__
#define __app_params_h__

#include "frmwrk.h"

#define	PARA_NOSETUP					"-nosetup"
#define	PARA_STATS						"-stats"
#define PARA_NUMBUFFS					"-numringbuf"
#define PARA_FRAMEWORK					"-framework"
#define PARA_FRAMEWORK_NULL				"null"
#define PARA_FRAMEWORK_BVIEW			"bview"
#define PARA_FRAMEWORK_BDWIN			"bdirectwindow"
#define PARA_FRAMEWORK_BDWINLC			"bdirectwindowlc"
#define PARA_FRAMEWORK_BWINSCR			"bwindowscreen"
#define PARA_TEXTUREFILE				"-texfile"
#define PARA_SAMPLING					"-sampling"
#define PARA_SAMPLING_CONST_NEAREST		"const_nearest"
#define PARA_SAMPLING_CONST_LINEAR		"const_linear"
#define PARA_SAMPLING_NEAREST_NEAREST	"nearest_nearest"
#define PARA_SAMPLING_NEAREST_LINEAR	"nearest_linear"
#define PARA_SAMPLING_LINEAR_NEAREST	"linear_nearest"
#define PARA_SAMPLING_LINEAR_LINEAR		"linear_linear"

#define DESC_FRAMEWORK_NULL				"one back buffer, no flipping to front buffer"
#define DESC_FRAMEWORK_BVIEW			"front buffer is separate from ring buffers"
#define DESC_FRAMEWORK_BDWIN			"front buffer is separate from ring buffers"
#define DESC_FRAMEWORK_BDWINLC			"ditto but without a separate flipping thread"
#define DESC_FRAMEWORK_BWINSCR			"front buffer is one of ring buffers"

#define DESC_SAMPLING_CONST_NEAREST		"no mipmapping, nearest sampling"
#define DESC_SAMPLING_CONST_LINEAR		"no mipmapping, linear sampling"
#define DESC_SAMPLING_NEAREST_NEAREST	"nearest LOD, nearest sampling"
#define DESC_SAMPLING_NEAREST_LINEAR	"nearest LOD, linear sampling"
#define DESC_SAMPLING_LINEAR_NEAREST	"linear LOD, nearest sampling"
#define DESC_SAMPLING_LINEAR_LINEAR		"linear LOD, linear sampling"

#define	MIN_NUM_RING_BUFFERS			1
#define MAX_NUM_RING_BUFFERS			4

enum FRAMEWORK_TYPE
{
	FRAMEWORK_NULL,
	FRAMEWORK_BVIEW,
	FRAMEWORK_BDIRECTWINDOW,
	FRAMEWORK_BDIRECTWINDOW_LC,
	FRAMEWORK_BWINDOWSCREEN
};

class AppParams
{
public:

	AppParams() {};
	~AppParams() {};

	FRAMEWORK_TYPE				frameworkType;
	FrameworkParams				frameworkParams;

	uint32						rendSampling;

	struct PixelFormatText
	{
		color_space					space;
		const char *				textual;
	};

	static const uint32		 	 nPixFormats;
	static const PixelFormatText pixFmtTxt[];
	static const PixelFormatText pixFmtId[];
};

#endif // __app_params_h__
