#ifndef __bitmap_h__
#define __bitmap_h__

#include <Window.h>
#include <View.h>
#include <Bitmap.h>
#include <String.h>

#include "frmwrk.h"

// view ///////////////////////////////////////////////////////////////////

class FlipView : public BView
{
	friend				class FrmBmpWindow; 

	struct BUFFER_RECORD
	{
		BBitmap	*		bitmap;
		sem_id			writeLock;
		bool			unlockAtActivate;
	}
					   *mBack;

	int32				mNumRingBuf;
	int32				mFlipSelector;
	int32				mDrawSelector;

	bool				mMinimized;
	
	void				DestroyRingLocks();

public:

	FlipView(FrameworkParams &params, status_t &error, BString &errorString);
	~FlipView();

	virtual void		MessageReceived(BMessage *message);
	virtual void		WindowActivated(bool active);
	virtual void		Draw(BRect updateRect);
};

// window /////////////////////////////////////////////////////////////////

class FrmBmpWindow : public BWindow, public Framework
{
	FlipView *			mView;

	uint32				mDrawSelector;

public:

	FrmBmpWindow(FrameworkParams &params, status_t &error, BString &errorString);
	~FrmBmpWindow();

	virtual bool		QuitRequested();

	// interface methods to the drawing thread
	virtual status_t	frame_open(BUFFER_DESC &desc);
	virtual void		frame_close();
	// warning: above methods to be invoked from outside this window's thread,
	// 			thus using methods of this window from within the above takes
	//			locking this window's looper first!
};

#endif //__bitmap_h__
