#ifndef __frmwrk_h__
#define __frmwrk_h__

#include <GraphicsDefs.h>
#include <Point.h>

class Framework
{
public:

	struct BUFFER_DESC
	{
		int32			frameHeight;
		int32			frameWidth;
		color_space		pixelFormat;
		uint32			rowStride;
		void *			pBits;
	};

	// interface to the drawing thread
	virtual status_t	frame_open(BUFFER_DESC &) = 0;
	virtual void	 	frame_close() = 0;

	static const char *	__painter_name()
	{ return "an_amazing_drawing_thread"; }
};

class FrameworkParams
{
public:

	uint32 				numRingBuffers;
	color_space			pixelFormat;
	BPoint				frameBounds;
};

#endif // __frmwrk_h__
