#ifndef __MEMBLT_H__
#define __MEMBLT_H__

#define x86_memblt_long_unaligned(src, dest, length)		\
asm volatile (												\
				"pushl %%ecx\n\t"							\
				"movl %0,%%esi\n\t"							\
				"movl %1,%%edi\n\t"							\
															\
				"pushl %%ecx\n\t"							\
				"shrl $2,%%ecx\n\t"							\
			"rep\n\t"										\
				"movsl\n\t"									\
				"popl %%ecx\n\t"							\
				"andl $3,%%ecx\n\t"							\
			"rep\n\t"										\
				"movsb\n\t"									\
															\
				"popl %%ecx"								\
				: : "q" (src), "q" (dest), "c" (length)		\
				: /* "%ecx", */ "%esi", "%edi" )

#define x86_memblt_long_aligned(src, dest, length)			\
asm volatile (												\
				"pushl %%eax\n\t"							\
				"pushl %%ecx\n\t"							\
				"movl %0,%%esi\n\t"							\
				"movl %1,%%edi\n\t"							\
															\
				"leal (%%edi,%%edi,2),%%ecx\n\t"			\
				"andl $3,%%ecx\n\t"							\
				"subl %%ecx,%%eax\n\t"     					\
				"jle __EndBytes\n\t"						\
			"rep\n\t"										\
				"movsb\n\t"									\
				"movl %%eax,%%ecx\n\t"						\
				"andl $3,%%eax\n\t"							\
				"shrl $2,%%ecx\n\t"							\
			"rep\n\t"										\
				"movsl\n\t"									\
"__EndBytes:\n\t"											\
				"addl %%eax,%%ecx\n\t"						\
			"rep\n\t"										\
				"movsb\n\t"									\
															\
				"popl %%ecx\n\t"							\
				"popl %%eax"								\
				: : "q" (src), "q" (dest), "a" (length)		\
				: /* "%eax", "%ecx", */ "%esi", "%edi" )

// above code by Paul Hsieh, parts by Ken Silverman.

inline void any_memblt_32bytes_unrolled(const void *src, void *dst, uint32 length)
{
	for (uint32 i = 0; i < length / (4 * sizeof(uint64)); i++)
	{
		((uint64 *)dst)[0] = ((const uint64 *)src)[0];
		((uint64 *)dst)[1] = ((const uint64 *)src)[1];
		((uint64 *)dst)[2] = ((const uint64 *)src)[2];
		((uint64 *)dst)[3] = ((const uint64 *)src)[3];
		dst = (uint64 *) dst + 4;
		src = (const uint64 *) src + 4;
	}
	for (uint32 i = 0; i < (length % (4 * sizeof(uint64))) / sizeof(uint64); i++)
	{
		((uint64 *)dst)[0] = ((const uint64 *)src)[0];
		dst = (uint64 *) dst + 1;
		src = (const uint64 *) src + 1;
	}
	for (uint32 i = 0; i < (length % sizeof(uint64)) / sizeof(uint8); i++)
		((uint8 *)dst)[i] = ((const uint8 *)src)[i];
}
// above code by David McPaul, parts by me.

#endif // __MEMBLT_H__
